
;				PIC16F84A	LCD CLOCK BONTON CLOCK Ver1.05
;
;
;	RA0	R/W
;	RA1	E
;	RA2	RS
;	RA3
;	RA4	MCLR
;
;	RB0	DB4
;	RB1	DB5
;	RB2	DB6
;	RB3	DB7
;	RB4
;	RB5	PB SEC	
;	RB6	PB MIN
;	RB7	PB HOUR
;
;	OSC1	4.194304MHz
;	OSC2	4.194304MHz
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	list      p=16F84A	; |󎞂ɃXgt@C܂B	;;łǂPICgw肵܂B
	#include <p16F84A.inc>	; 16F84Ap`t@Cǂݍ݂܂B	;;
		
	;ASMt@Cł́u;vE͓ǂݎ܂̂ŒӏȂ藎\łB

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
										@
	__CONFIG _CP_OFF & _WDT_OFF & _PWRTE_ON & _HS_OSC	;4.194304MHz	(_HS_OSC͊OɃNbNƂӖj
	;łB@ɂĂ낢茈߂͂܂A͗ɊoĂB 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	errorlevel  -302	; |󎞂302G[oȂ悤ɂ܂B							
	ORG	000H
	GOTO	INIT 

	ORG	004H
	GOTO	INT
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;---- [` ----
INIT:
	
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;vÓuGOTOvȂǂ̖߂Ȃ艺։ւƍ~čs܂B
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	BSF	STATUS,RP0	;BANK1ɐ؂ւ	STATUS,RP0PɂƂӖ

	MOVLW	B'00000'	;RA0`4ׂďo	(1͓́A 0o͂̈Ӗj
	MOVWF	TRISA		;L̏TRISAiRÅǗj֊i[

	MOVLW	B'11100000'	;RB0`4ó@RB5`7	(1͓́A 0o͂̈Ӗj
	MOVWF	TRISB		;L̏TRISBiRB̊Ǘj֊i[

	MOVLW   B'00000111'	;荞 1:256
	MOVWF	OPTION_REG

	BCF	STATUS,RP0	;BANK0ɐ؂ւ	STATUS,RP0OɂƂӖ

	BSF	INTCON,T0IE	;^C}
	BSF	INTCON,GIE	;S̊

	;PICɂ͐ݒ肷ӏBANK0BANK1ƂQӏ܂Bo͏BANK1ɂ܂̂STATUS,RP0ƂƂ
	;BANK1ɐ؂ւĐݒ芮BANK0ɖ߂܂B

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	SELECTA		EQU	PORTA
	RW		EQU	D'0'	;(H:READ MODE / L:WRITE MODE) 
	E		EQU	D'1'	;(L>H>L:ENABLE)
	RS		EQU	D'2'	;(H:DATA MODE / L:CONTROL MODE)

	DATAB		EQU	PORTB
	BUSY		EQU	D'3'

	ADJUST		EQU	PORTB	;Ԓ{^
	SEC		EQU	D'5'	
	MIN		EQU	D'6'
	HOUR		EQU	D'7'

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	COUNTER1	EQU	20H	;JE^[f[^1
	TIMER1		EQU	21H	;^C}[f[^1
	TIMER2		EQU	22H	;^C}[f[^2
	DISP_DATA	EQU	23H	;\f[^

	COUNT_1S	EQU	26H	;COUNTf[^	b
	COUNT_10S	EQU	27H	;COUNTf[^	10b
	COUNT_1M	EQU	28H	;COUNTf[^	
	COUNT_10M	EQU	29H	;COUNTf[^	10
	COUNT_1H	EQU	2AH	;COUNTf[^	
	COUNT_10H	EQU	2BH	;COUNTf[^	10
	COUNT_H		EQU	2CH	;COUNT JEg
	POINTER		EQU	2DH	;|C^[


	DISP_DATA0	EQU	30H	;\f[^0
	DISP_DATA1	EQU	31H	;\f[^1
	DISP_DATA2	EQU	32H	;\f[^2


;			EQU	46H	;
;			EQU	47H	;
;			EQU	48H	;
	W_TEMP		EQU 	49H 	;WWX^Ҕ
	PCLATH_TEMP	EQU	4AH	;PCLATHҔ
	STATUS_TEMP	EQU	4BH	;STATUSҔ
	OVFL0		EQU	4CH	;荞݃I[o[t[0
	OVFL1		EQU	4DH	;荞݃I[o[t[1
	OVFL2		EQU	4EH	;荞݃I[o[t[2
 	FLAG		EQU	4FH	;etO
					;0	荞0	DISP MOVE	
					;1	荞1	POINTER MOVE
					;2	荞2	CLOCK MOVE
					;3	荞3	ADJ TIMING	
					;4	S{^J
					;5	|C^[L
					;6	

	MOVLW	D'4'
	MOVWF	OVFL0
	MOVLW	D'2'
	MOVWF	OVFL1
	MOVLW	D'2'
	MOVWF	OVFL2
	
	MOVLW	H'30'
	MOVWF	COUNT_1S
	MOVWF	COUNT_10S
	MOVWF	COUNT_1M
	MOVWF	COUNT_10M
	MOVWF	COUNT_1H
	MOVWF	COUNT_10H

	MOVLW	D'8'
	MOVWF	DISP_DATA1

	MOVLW	H'3A'
	MOVWF	POINTER

	MOVLW	D'0'
	MOVWF	SELECTA
	MOVWF	DATAB
	MOVWF	COUNT_H
	MOVWF	DISP_DATA0
	MOVWF	DISP_DATA1
	MOVWF	DISP_DATA2
	MOVWF	FLAG

	GOTO	MAIN	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; ---- 荞݃[` ----

INT:
	MOVWF	W_TEMP			;WWX^Ҕ
	MOVF	STATUS,W		;STATUSo
	MOVWF	STATUS_TEMP		;STATUSҔ 
	MOVF	PCLATH,W		;PCLATHo
	MOVWF	PCLATH_TEMP		;PCLATHҔ 

	BCF	INTCON,T0IF		;TMR0I[o[t[tOOFF 
	BSF	FLAG,3			;FLAG,3 ON	ADJ TIMING

	DECFSZ	OVFL0,F			;荞݃I[o[t[0
	GOTO	INT_1
	MOVLW	D'4'			;
	MOVWF	OVFL0			;荞݃I[o[t[0
	BSF	FLAG,0			;FLAG,0 ON

	DECFSZ	OVFL1,F			;荞݃I[o[t[1
	GOTO	INT_1
	MOVLW	D'2'			;
	MOVWF	OVFL1			;荞݃I[o[t[1
	BSF	FLAG,1			;FLAG,1 ON

	DECFSZ	OVFL2,F			;荞݃I[o[t[2
	GOTO	INT_1
	MOVLW	D'2'			;
	MOVWF	OVFL2			;荞݃I[o[t[2
	BSF	FLAG,2			;FLAG,2 ON
 
INT_1
	MOVF	PCLATH_TEMP,W		;PCLATH߂
	MOVWF	PCLATH
	MOVF	STATUS_TEMP,W		;STATUS߂
	MOVWF	STATUS
	SWAPF	W_TEMP,F		;WWX^߂
	SWAPF	W_TEMP,W
	RETFIE
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN
	CALL	LCD_INTIALIZE		;INTIALIZE	

MAIN1
	CALL	PTN_0			;^Cg\	
	CALL	PTN_1			;|C^[
	CALL	PTN_2			;v
	CALL	ADJ			;ύX{^암

	GOTO	MAIN1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LCD_INTIALIZE				;INTIALIZE
	CALL	WAIT_5M			;WAIT 5mS
	CALL	WAIT_5M			;WAIT 5mS
	CALL	WAIT_5M			;WAIT 5mS
	BCF	SELECTA,RW		;R/W OFF (WRITE MODE)
	BCF	SELECTA,E		;E OFF (ENABLE OFF)
	BCF	SELECTA,RS		;RS OFF (CONTROL MODE)

	MOVLW	D'3'
	MOVWF	COUNTER1
LCD_INTIALIZE1
	MOVLW	B'00000011'		;TO 8BIT MODE
	MOVWF	DATAB
	BSF	SELECTA,E		;ENABLE
	NOP
	BCF	SELECTA,E		;ENABLE SET
	CALL	WAIT_5M			;WAIT 5mS
 
	DECFSZ	COUNTER1,F		;
	GOTO	LCD_INTIALIZE1

	MOVLW	B'00000010'		;TO 4BIT MODE
	MOVWF	DATAB
	BSF	SELECTA,E		;ENABLE
	NOP
	BCF	SELECTA,E		;ENABLE SET
	CALL	WAIT_5M			;WAIT 5mS	

	MOVLW	B'00101000'		;TO 2LINE MODE
	CALL	LCD_CON			;

	MOVLW	B'00001000'		;TO LCD OFF
	CALL	LCD_CON	

	MOVLW	B'00000001'		;TO LCD CLEAR
	CALL	LCD_CON	

	MOVLW	B'000001010'		;TO ENTY MODE
	CALL	LCD_CON			;

	MOVLW	B'00001100'		;TO LCD ON
	CALL	LCD_CON	

	RETURN	 	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WAIT_5M					;WAIT 5mS
	MOVLW	D'220'
	MOVWF	TIMER1
WAIT_5M_1
	MOVLW	D'5'
	MOVWF	TIMER2
WAIT_5M_2
	NOP
	DECFSZ	TIMER2,F
	GOTO	WAIT_5M_2
	DECFSZ	TIMER1,F
	GOTO	WAIT_5M_1
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LCD_CLOCK_CODE				;CLOCK CODE
	MOVLW	B'11000000'		;TO LCD SECOND LINE
	CALL	LCD_CON	
	MOVF	COUNT_10H,W		;
	CALL	LCD_SEND
	MOVF	COUNT_1H,W		;
	CALL	LCD_SEND
	MOVF	POINTER,W		;
	CALL	LCD_SEND
	MOVF	COUNT_10M,W		;
	CALL	LCD_SEND
	MOVF	COUNT_1M,W		;
	CALL	LCD_SEND
	MOVF	POINTER,W		;
	CALL	LCD_SEND
	MOVF	COUNT_10S,W		;
	CALL	LCD_SEND
	MOVF	COUNT_1S,W		;
	CALL	LCD_SEND

	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
LCD_CON					;LCD CONTROL MODE	
	MOVWF	DISP_DATA
	CALL	WAIT_BUSY		;WAIT LCD BUSY 

	BCF	SELECTA,RW		;R/W OFF (WRITE MODE)
	BCF	SELECTA,RS		;RS ON (CONTROL MODE)

	SWAPF	DISP_DATA,W		;TO HIGH BITS CHANGE LOW BITS
	MOVWF	DISP_DATA
	MOVF	DISP_DATA,W		;
	MOVWF	DATAB			;
	BSF	SELECTA,E		;ENABLE
	NOP
	BCF	SELECTA,E		;ENABLE SET

	SWAPF	DISP_DATA,W		;TO HIGH BITS CHANGE LOW BITS
	MOVWF	DISP_DATA
	MOVF	DISP_DATA,W		;
	MOVWF	DATAB			;
	BSF	SELECTA,E		;ENABLE
	NOP
	BCF	SELECTA,E		;ENABLE SET

	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
LCD_SEND				;LCD DATA SEND	
	MOVWF	DISP_DATA
	CALL	WAIT_BUSY		;WAIT LCD BUSY 

	BCF	SELECTA,RW		;R/W OFF (WRITE MODE)
	BSF	SELECTA,RS		;RS ON (DATA MODE)

	SWAPF	DISP_DATA,W		;TO HIGH BITS CHANGE LOW BITS
	MOVWF	DISP_DATA
	MOVF	DISP_DATA,W		;
	MOVWF	DATAB			;
	BSF	SELECTA,E		;ENABLE
	NOP
	BCF	SELECTA,E		;ENABLE SET

	SWAPF	DISP_DATA,W		;TO HIGH BITS CHANGE LOW BITS
	MOVWF	DISP_DATA
	MOVF	DISP_DATA,W		;
	MOVWF	DATAB			;
	BSF	SELECTA,E		;ENABLE
	NOP
	BCF	SELECTA,E		;ENABLE SET

	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WAIT_BUSY				;WAIT LCD BUSY 
	BCF	SELECTA,E		;E OFF (ENABLE OFF)
	BCF	SELECTA,RS		;RS OFF (CONTROL MODE)
	BSF	SELECTA,RW		;R/W ON (READ MODE)

	BSF	STATUS,RP0		;BANK1
	MOVLW	B'11101000'
	MOVWF	TRISB			;RB3 
	BCF	STATUS,RP0		;BANK0
	BSF	SELECTA,E		;READ ENABLE
	NOP
	BTFSS	DATAB,BUSY		;DATAB,BUSY ON?
	GOTO	WAIT_BUSY1		;NO
					;YES
	BCF	SELECTA,E		;ENABLE SET
	NOP
	BSF	SELECTA,E		;ENABLE
	NOP
	BCF	SELECTA,E		;ENABLE SET
	GOTO	WAIT_BUSY

WAIT_BUSY1
	BCF	SELECTA,E		;ENABLE SET
	BSF	STATUS,RP0		;BANK1
	MOVLW	B'11100000'
	MOVWF	TRISB			;RB3 o
	BCF	STATUS,RP0		;BANK0

	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	100H
PTN_0
					;^Cg\
	MOVLW	H'01'
	MOVWF	PCLATH			;

	BTFSS	FLAG,0			;FLAG,0 ON?	;荞 
	RETURN				;NO
					;YES
	BCF	FLAG,0			;FLAG,0 OFF	;荞
 
PTN_0_1
	MOVLW	B'00000010'		;TO LCD FIRST LINE
	CALL	LCD_CON	

	MOVF	DISP_DATA0,W		;
	MOVWF	DISP_DATA1		;

	MOVLW	D'8'			;
	MOVWF	DISP_DATA2		;

PTN_0_2
	MOVF	DISP_DATA1,W		;
	ADDWF	PCL,F			;

	MOVLW	H'20'			;1
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;2
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;3
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;4
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;5
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;6
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;7
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;8
	CALL	LCD_SEND
	GOTO	PTN_0_3

	MOVLW	A'B'			;1
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'O'			;2
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'N'			;3
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'T'			;4
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'O'			;5
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'N'			;6
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;7
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'C'			;8
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'L'			;9
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'O'			;10
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'C'			;11
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'K'			;12
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;13
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'V'			;14
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'e'			;15
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'r'			;16
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'1'			;17
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'.'			;18
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'0'			;19
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	A'5'			;20
	CALL	LCD_SEND
	GOTO	PTN_0_3

	MOVLW	H'20'			;1
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;2
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;3
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;4
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;5
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;6
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;7
	CALL	LCD_SEND
	GOTO	PTN_0_3
	MOVLW	H'20'			;8
	CALL	LCD_SEND
	GOTO	PTN_0_3

PTN_0_3
	INCF	DISP_DATA1,F		;DISP_DATA1+1=DISP_DATA1
	INCF	DISP_DATA1,F		;DISP_DATA1+1=DISP_DATA1
	INCF	DISP_DATA1,F		;DISP_DATA1+1=DISP_DATA1

	DECFSZ	DISP_DATA2,F		;DISP_DATA2-1=0?
	GOTO	PTN_0_2			;NO
					;YES
	INCF	DISP_DATA0,F		;DISP_DATA0+1=DISP_DATA0
	INCF	DISP_DATA0,F		;DISP_DATA0+1=DISP_DATA0
	INCF	DISP_DATA0,F		;DISP_DATA0+1=DISP_DATA0

	MOVLW	D'108'			;(8+20+8)x3=108
	SUBWF	DISP_DATA1,W
	BTFSS	STATUS,C		;D'108'-DISP_DATA1=0?
	GOTO	PTN_0_4			;NO
					;YES	
	CLRF	DISP_DATA0		;
	CLRF	DISP_DATA1		;

PTN_0_4	
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PTN_1					;|C^[
	BTFSS	FLAG,1			;FLAG,1 ON?	;荞 
	RETURN				;NO
					;YES
	BCF	FLAG,1			;FLAG,1 OFF

	BTFSC	FLAG,5			;FLAG,5 ON?	;|C^[L
	GOTO	PTN_1_1			;YES
					;NO
	MOVLW	H'20'			;
	MOVWF	POINTER
	BSF	FLAG,5			;FLAG,5 ON	;|C^[L
	GOTO	PTN_1_2

PTN_1_1
	MOVLW	H'3A'			;uFv
	MOVWF	POINTER
	BCF	FLAG,5			;FLAG,5 OFF	;|C^[L

PTN_1_2
	CALL	LCD_CLOCK_CODE		;CLOCK CODE
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PTN_2					;v
	BTFSS	FLAG,2			;FLAG,2 ON?	;荞 
	RETURN				;NO
					;YES
	BCF	FLAG,2			;FLAG,2 OFF

PTN_2_S
	INCF	COUNT_1S		;COUNTf[^b
	MOVLW	D'58'			;H'30'(D'48'+10=D'58')
	SUBWF	COUNT_1S,W
	BTFSS	STATUS,C		;COUNT_1S-58=0?
	GOTO	PTN_2_1			;NO
	MOVLW	H'30'			;YES
	MOVWF	COUNT_1S

	INCF	COUNT_10S		;COUNTf[^10b
	MOVLW	D'54'			;H'30'(D'48'+6=D'54')
	SUBWF	COUNT_10S,W
	BTFSS	STATUS,C		;COUNT_10S-54=0?
	GOTO	PTN_2_1			;NO
	MOVLW	H'30'			;YES
	MOVWF	COUNT_10S

PTN_2_M
	INCF	COUNT_1M		;COUNTf[^
	MOVLW	D'58'			;H'30'(D'48'+10=D'58')
	SUBWF	COUNT_1M,W
	BTFSS	STATUS,C		;COUNT_1M-58=0?
	GOTO	PTN_2_1			;NO
	MOVLW	H'30'			;YES
	MOVWF	COUNT_1M

	INCF	COUNT_10M		;COUNTf[^10
	MOVLW	D'54'			;H'30'(D'48'+6=D'54')
	SUBWF	COUNT_10M,W
	BTFSS	STATUS,C		;COUNT_10M-54=0?
	GOTO	PTN_2_1			;NO
	MOVLW	H'30'			;YES
	MOVWF	COUNT_10M

PTN_2_H	
	INCF	COUNT_H			;COUNTJEg
	MOVLW	D'24'
	SUBWF	COUNT_H,W
	BTFSS	STATUS,C		;COUNT_H-24=0?
	GOTO	PTN_2_H1		;NO
	MOVLW	H'30'			;YES
	MOVWF	COUNT_1H
	MOVWF	COUNT_10H
	CLRF	COUNT_H			;COUNTJEg
	GOTO	PTN_2_1
PTN_2_H1
	INCF	COUNT_1H		;COUNTf[^
	MOVLW	D'58'			;H'30'(D'48'+10=D'58')
	SUBWF	COUNT_1H,W
	BTFSS	STATUS,C		;COUNT_1H-58=0?
	GOTO	PTN_2_1			;NO
	MOVLW	H'30'			;YES
	MOVWF	COUNT_1H

	INCF	COUNT_10H		;COUNTf[^10
	MOVLW	D'54'			;H'30'(D'48'+6=D'54')
	SUBWF	COUNT_10H,W
	BTFSS	STATUS,C		;COUNT_10H-54=0?
	GOTO	PTN_2_1			;NO
	MOVLW	H'30'			;YES
	MOVWF	COUNT_10H

PTN_2_1	
	CALL	LCD_CLOCK_CODE		;CLOCK CODE
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ADJ					;ύX{^암
	BTFSS	FLAG,3			;FLAG,3 ON?	ADJ TIMING
	RETURN				;NO
					;YES
	BCF	FLAG,3			;FLAG,3 OFF

	BTFSC	ADJUST,SEC		;bύX{^
	GOTO	ADJ1			;NO	
					;YES
	BTFSS	FLAG,4			;FLAG,4	ON?	;S{^J
	GOTO	ADJ5			;NO
					;YES
	CALL	PTN_2_S			;f[^b
	GOTO	ADJ4
	
ADJ1	
	BTFSC	ADJUST,MIN		;ύX{^
	GOTO	ADJ2			;NO	
					;YES
	BTFSS	FLAG,4			;FLAG,4	ON?	;S{^J
	GOTO	ADJ5			;NO
					;YES
	CALL	PTN_2_M			;f[^
	GOTO	ADJ4
	
ADJ2	
	BTFSC	ADJUST,HOUR		;ύX{^
	GOTO	ADJ3			;NO	
					;YES
	BTFSS	FLAG,4			;FLAG,4	ON?	;S{^J
	GOTO	ADJ5			;NO
					;YES
	CALL	PTN_2_H			;f[^
	GOTO	ADJ4
	
ADJ3
	BSF	FLAG,4			;FLAG,4	ON	;S{^J
	GOTO	ADJ5

ADJ4
	BCF	FLAG,4			;FLAG,4	OFF	;S{^J

ADJ5
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	END
